/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

int n, i, t1, t2;
long long p[100010], q[100010], a, b, sum, otv, k;

int main()
{
    freopen("race.in", "r", stdin);
    freopen("race.out", "w", stdout);

    scanf("%d %d %d %I64d %I64d", &n, &t1, &t2, &a, &b);
    if(a >= b)
    {
        for(i = 0; i < n; i++)
            scanf("%I64d", &p[i]);
    }
    else
    {
        swap(a , b );
        swap(t1, t2);
        for(i = n - 1; i >= 0; i--)
            scanf("%I64d", &p[i]);
    }

    q[0] = p[0];
    for(i = 1; i < n; i++)
        q[i] = p[i] - p[i - 1];

    otv = sum = 0;
    for(i = 0; i < n; i++)
    {
        sum += q[i];

        if(sum <= 0)
            continue;

        k = (sum - 1) / a + 1;
        otv += k;

        if(i < n)
        {
            sum -= a * k;
            q[i] -= a * k;
        }

        if(i + t1 < n)
            q[i + t1] += (a - b) * k;

        if(i + t1 + t2 < n)
            q[i + t1 + t2] += b * k;
    }

    printf("%I64d\n", otv);

    return 0;
}







