/* GCC */

#include <fstream>
#include <vector>
#include <numeric>
#include <algorithm>

using namespace std;

vector<size_t> v[1234568];
bool ts[1234568] = {}, used[1234568] = {};
size_t tmp1, tmp2, mx(0), timer(0), tin[1234568], fup[1234568];

void dfs(size_t u, size_t p = 0)
{
    used[u] = true;
    size_t children = 0, to;
    fup[u] = tin[u] = timer++;
    for(size_t i = 0; i < v[u].size(); ++i)
    {
        to = v[u][i];
        if(to == p)
            continue;
        if(used[to])
        {
            if(fup[u] > tin[to])
                fup[u] = tin[to];
        }
        else
        {
            dfs(to, u);
            if(fup[u] > fup[to])
                fup[u] = fup[to];
            if(p != 0 && fup[to] >= tin[u])
                ts[u] = true;
            ++children;
        }
    }
    if(p == 0 && children > 1)
        ts[u] = true;
}

int main(void)
{
    ios_base::sync_with_stdio(false);
    ifstream in("crossing.in");
    while(true)
    {
        in >> tmp1 >> tmp2;
        if(in.eof())
            break;
        if(tmp1 > mx)
            mx = tmp1;
        if(tmp2 > mx)
            mx = tmp2;
        v[tmp1].push_back(tmp2);
        v[tmp2].push_back(tmp1);
    }
    in.close();
    dfs(1);
    ofstream out("crossing.out");
    size_t i = 1;
    for(; i <= mx; ++i)
        if(ts[i])
        {
            out << i++;
            break;
        }
    for(; i <= mx; ++i)
        if(ts[i])
            out << ' ' << i;
    out << '\n';
    out.close();
    return 0;
}
